<?xml version="1.0" ?>

<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/TR/WD-xsl">

<xsl:template match="/">
	<opml version="1.0">
		<head>
			<title><xsl:value-of select="list/@name"/></title>
			<!-- other possible elements in head 
				<dateCreated></dateCreated>
				<dateModified></dateModified>
				<ownerName></ownerName>
				<ownerEmail></ownerEmail>
				<expansionState></expansionState>
				<vertScrollState></vertScrollState>
				<windowTop></windowTop>
				<windowLeft></windowLeft>
				<windowBottom></windowBottom>
				<windowRight></windowRight>
			-->
		</head>
		<body>
			
			<!-- generate a row for each item in the list -->
			<xsl:apply-templates select="list/items/item[not(@parent) or (@parent='')]"/>
			
		</body>
	</opml>
</xsl:template>

<xsl:template match="item">
	<!-- generate a row for each item in the list -->
	<outline>
		<!-- generate the columns for this item -->
		<xsl:for-each select="column">
			<!-- check for type of column -->
			<xsl:choose>
				<!-- look for the item column -->
				<xsl:when test=".[@columnid='c16']">
					<xsl:attribute name="text"><xsl:value-of select="value"/></xsl:attribute>
				</xsl:when>
				<!-- look for known column names -->
				<xsl:when test="/list/columns/columndef[@id=context()/@columnid][@name='type']">
					<xsl:if test=".[value!='']"><xsl:attribute name="type"><xsl:value-of select="value"/></xsl:attribute></xsl:if>
				</xsl:when>
				<xsl:when test="/list/columns/columndef[@id=context()/@columnid][@name='xmlUrl']">
					<xsl:if test=".[value!='']"><xsl:attribute name="xmlUrl"><xsl:value-of select="value"/></xsl:attribute></xsl:if>
				</xsl:when>
				<xsl:when test="/list/columns/columndef[@id=context()/@columnid][@name='htmlUrl']">
					<xsl:if test=".[value!='']"><xsl:attribute name="htmlUrl"><xsl:value-of select="value"/></xsl:attribute></xsl:if>
				</xsl:when>
			</xsl:choose>
		</xsl:for-each>
		<!-- generate rows for each child item -->
		<xsl:apply-templates select="/list/items/item[@parent=context()/@index]"/>
	</outline>
</xsl:template>

</xsl:stylesheet>
