<?xml version="1.0" ?>

<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" encoding="utf-8"/>

<xsl:template match="/">
	<opml version="1.0">
		<head>
			<title><xsl:value-of select="list/@name"/></title>
			<!-- other possible elements in head 
				<dateCreated></dateCreated>
				<dateModified></dateModified>
				<ownerName></ownerName>
				<ownerEmail></ownerEmail>
				<expansionState></expansionState>
				<vertScrollState></vertScrollState>
				<windowTop></windowTop>
				<windowLeft></windowLeft>
				<windowBottom></windowBottom>
				<windowRight></windowRight>
			-->
		</head>
		<body>
			
			<!-- generate a row for each item in the list -->
			<xsl:apply-templates select="list/items/item[not(@parent) or (@parent='')]"/>
			
		</body>
	</opml>
</xsl:template>

<xsl:template match="item">
	<!-- generate a row for each item -->
	<outline>
		<!-- generate the columns for this item -->
		<xsl:for-each select="column">
			<!-- check for type of column -->
			<xsl:choose>
				<!-- look for the item column -->
				<xsl:when test="@columnid='c16'">
					<xsl:attribute name="text">
						<xsl:value-of select="value"/>
					</xsl:attribute>
				</xsl:when>
				<!-- output all other columns as attributes -->
				<xsl:otherwise>
					<xsl:if test="value!=''">
						<xsl:attribute name="{/list/columns/columndef[@id=current()/@columnid]/@name}">
							<xsl:value-of select="value"/>
						</xsl:attribute>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
		<!-- generate rows for each child item -->
		<xsl:apply-templates select="/list/items/item[@parent=current()/@index]"/>
	</outline>
</xsl:template>

</xsl:stylesheet>
